﻿using System;
using System.Collections;
using System.Windows;

using DevExpress.Xpf.Grid;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.gridControl.ItemsSource = new nwindDataSetTableAdapters.OrdersTableAdapter().GetData();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 그리드 컨트롤 커스텀 컬럼 정렬 처리하기 - gridControl_CustomColumnSort(sender, e)

        /// <summary>
        /// 그리드 컨트롤 커스텀 컬럼 정렬 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void gridControl_CustomColumnSort(object sender, CustomColumnSortEventArgs e)
        {
            if(e.Column.FieldName == "ShipName")
            {
                e.Handled = true;

                string value1 = e.Value1.ToString();
                string value2 = e.Value2.ToString();

                if(value1.Length > value2.Length)
                {
                    e.Result = 1;
                }
                else if(value1.Length == value2.Length)
                {
                    e.Result = Comparer.Default.Compare(value1, value2);
                }
                else
                {
                    e.Result = -1;
                }
            }
        }

        #endregion
    }
}